
@echo off
SET LogPath=C:\OEM\AcerLogs\Useralaunch.Log
ECHO.>>%LogPath%
ECHO %DATE% %TIME%[Log START]  ============ %~dpnx0 ============ >> %LogPath%
SETLOCAL ENABLEDELAYEDEXPANSION
pushd "%~dp0"


REM for /f "skip=2 tokens=3" %%A in ('reg query HKLM\Software\OEM\Metadata /v Brand') do set Brand=%%A
REM ECHO %DATE% %TIME%[Log TRACE]  SET Custom DATA File NAME by Brand >> %LogPath%
REM SET CustomDATA=.\CDF\custom.data.acerlt.xml
REM if /I "%Brand%" == "Gateway" set CustomDATA=gateway-abb.json
REM if /I "%Brand%" == "Packard" set CustomDATA=packardbell-abb.json


:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::
::::	
::::   DO Not Trim Trailing space............
::::
::::   Each Set Value in the end exist the Space for dism split paramter
::::   set APPXPackagePath_X86=!APPXPackagePath_X86!/dependencypackagepath:"%%d" 
::::
:::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::

SET APPXFileName=%1
IF /i "%PROCESSOR_ARCHITECTURE%" equ "AMD64" (
	call :GetParameter
	REM ECHO %DATE% %TIME%[Log TRACE]  dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X64!/CustomDataPath:"%CustomDATA%">>%LogPath% 2>&1
	REM dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X64!/CustomDataPath:"%CustomDATA%">>%LogPath% 2>&1
	ECHO %DATE% %TIME%[Log TRACE]  dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X64!/region="all">>%LogPath% 2>&1
	dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X64!/region="all">>%LogPath% 2>&1
) else (	
	call :GetParameter
	REM ECHO %DATE% %TIME%[Log TRACE]  dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X86!/CustomDataPath:"%CustomDATA%">>%LogPath% 2>&1
	REM dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X86!/CustomDataPath:"%CustomDATA%">>%LogPath% 2>&1
	ECHO %DATE% %TIME%[Log TRACE]  dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X86!/region="all">>%LogPath% 2>&1
	dism /online /english /add-provisionedappxpackage /packagepath:"!packagepath!" /licensepath:"!licensepath!" !DependencyPackage_X86!/region="all">>%LogPath% 2>&1
)
ECHO %DATE% %TIME%[Log TRACE]  got return code [%errorlevel%] >>%LogPath%
if %errorlevel% neq 0 (
	ECHO %DATE% %TIME%[Log TRACE]  Return code is [%errorlevel%], reboot and re-install. >>%LogPath%
	call :Reboot
) else (
	ECHO %DATE% %TIME%[Log TRACE]  Return code is [%errorlevel%], leave. >>%LogPath%
)

popd
SETLOCAL DISABLEDELAYEDEXPANSION
ECHO %DATE% %TIME%[Log LEAVE]  ============ %~dpnx0 ============ >> %LogPath%
ECHO.>>%LogPath%
exit /b 0



:GetParameter
:GetPackagePath_Start
REM Prepare PackagePath
::::
::::	20171124 Prevent module set parameter for *.appxbundle case, Remark [if /i "%APPXFileName%" neq "" goto :Method2] and [goto :GetPackagePath_END]
::::
REM if /i "%APPXFileName%" neq "" goto :Method2
:Method1
ECHO %DATE% %TIME%[Log TRACE]  dir /b *.appxbundle >> %LogPath%
dir /b *.appxbundle >> %LogPath% 2>&1
for /f "delims=" %%d in ('dir /b *.appxbundle') do (
	set packagepath=%%d
)	
REM goto :GetPackagePath_END
:Method2
ECHO %DATE% %TIME%[Log TRACE]  dir /b %APPXFileName%.appx >> %LogPath% 2>&1
dir /b %APPXFileName%.appx >> %LogPath% 2>&1
for /f "delims=" %%d in ('dir /b %APPXFileName%.appx') do (
	set packagepath=%%d
)

:GetPackagePath_END
ECHO %DATE% %TIME%[Log TRACE]  PackagePath is [%packagepath%]  >> %LogPath%


REM Prepare LicensePath
ECHO %DATE% %TIME%[Log TRACE]  dir /b *.xml >> %LogPath%
dir /b *.xml >> %LogPath% 2>&1
for /f "delims=" %%d in ('dir /b *.xml') do (
	set licensepath=%%d
)
ECHO %DATE% %TIME%[Log TRACE]  LicensePath is [%licensepath%]  >> %LogPath%


REM Prepare DependencyPackagePath
ECHO %DATE% %TIME%[Log TRACE]  dir /b *_x86*.appx >> %LogPath%
dir /b *_x86*.appx >> %LogPath% 2>&1
for /f "delims=" %%d in ('dir /b *_x86*.appx') do (
	set DependencyPackage_X86=!DependencyPackage_X86!/dependencypackagepath:"%%d" 
	ECHO !DATE! !TIME![Log TRACE]  Now DependencyPackage_X86 is [!DependencyPackage_X86!] >>%LogPath%
)
ECHO %DATE% %TIME%[Log TRACE]  dir /b *_x64*.appx >> %LogPath%
dir /b *_x64*.appx >> %LogPath% 2>&1
for /f "delims=" %%d in ('dir /b *_x64*.appx') do (
	set DependencyPackage_X64=!DependencyPackage_X64!/dependencypackagepath:"%%d" 
	ECHO !DATE! !TIME![Log TRACE]  Now DependencyPackage_X64 is [!DependencyPackage_X64!] >>%LogPath%
)
ECHO %DATE% %TIME%[Log TRACE]  Merge _x86.appx and _x64.appx For X64 >> %LogPath%
set DependencyPackage_X64=%DependencyPackage_X86%%DependencyPackage_X64%
ECHO %DATE% %TIME%[Log TRACE]  After merge DependencyPackage_X64 is [%DependencyPackage_X64%] >>%LogPath%
exit /b 0



:Reboot
if exist UWPFAIL_rebooted.tag (
	if exist c:\OEM\NAPP\D2D.tag (
		ECHO %DATE% %TIME%[Log TRACE]  c:\OEM\NAPP\D2D.tag found, exit /b 0 >>%LogPath%
		exit /b 0
	)
)
ECHO %DATE% %TIME%[Log TRACE]  acerReboot.exe with timeout 10 and Pause >>%LogPath%
ECHO %DATE% %TIME%[Log TRACE]  acerReboot.exe with timeout 10 and Pause >UWPFAIL_rebooted.tag
acerReboot.exe >>%LogPath% 2>&1
timeout /t 10
pause
exit /b 0